---
# tasks file

- package:
    name: "{{item}}"
    state: latest
  with_items: "{{ djangoconsensusapp_packages }}"
  tags:
    - djangoconsensusapp
    - djangoconsensusapp-install
    - djangoconsensusapp-configuration

- name: Generating RSA key for root
  user: name=root generate_ssh_key=yes
  tags:
    - djangoconsensusapp
    - djangoconsensusapp-install
    - djangoconsensusapp-configuration

- name: Get the django_consensus application
  git:
    repo: "{{ djangoconsensusapp_django_consensus_git_repo }}"
    dest: "{{ djangoconsensusapp_django_consensus_basedir }}"
    version: "{{ djangoconsensusapp_django_consensus_git_version }}"
    accept_hostkey: yes
    update: yes
  tags:
    - djangoconsensusapp
    - djangoconsensusapp-install
    - djangoconsensusapp-configuration
  notify:
      - restart djangoconsensusapp

- name: Install requirements
  pip:
    requirements: "{{ djangoconsensusapp_django_consensus_basedir}}/requirements.txt"
    virtualenv: "{{ djangoconsensusapp_django_consensus_basedir}}/env"
    virtualenv_python: python3
  tags:
    - djangoconsensusapp
    - djangoconsensusapp-install
    - djangoconsensusapp-configuration
  notify:
      - restart djangoconsensusapp

- name: Creates django_consensus media directory
  file:
    path: "{{ djangoconsensusapp_django_consensus_basedir }}/media"
    state: directory
    owner: "{{ djangoconsensusapp_user }}"
    group: "{{ djangoconsensusapp_group }}"
    mode: 0775
  tags:
    - djangoconsensusapp
    - djangoconsensusapp-install
    - djangoconsensusapp-configuration

- name: Creates django_consensus log directory
  file:
    path: "{{ djangoconsensusapp_django_consensus_log }}"
    state: directory
    owner: "{{ djangoconsensusapp_user }}"
    group: "{{ djangoconsensusapp_group }}"
    mode: 0775
  tags:
    - djangoconsensusapp
    - djangoconsensusapp-install
    - djangoconsensusapp-configuration

- template:
    src: "{{ item.path }}"
    dest: "/{{ item.path }}"
    owner: root
    mode: 0644
  with_items:
    - { path: 'etc/supervisor/conf.d/django_consensus.conf' }
    - { path: 'opt/django_consensus/django_consensus/local_settings.py' }
  tags:
      - djangoconsensusapp
      - djangoconsensusapp-configuration
  notify:
      - restart djangoconsensusapp

- command: "{{ item }}"
  with_items:
    - "{{ djangoconsensusapp_django_consensus_basedir }}/env/bin/python3 manage.py migrate"
    - "{{ djangoconsensusapp_django_consensus_basedir }}/env/bin/python3 manage.py collectstatic -c --no-input"
  args:
    chdir: "{{ djangoconsensusapp_django_consensus_basedir }}"
  tags:
    - djangoconsensusapp
    - djangoconsensusapp-configuration

- package:
    name: tox
    state: latest
  when: djangoconsensusapp_django_consensus_tests_run == 1
  tags:
    - djangoconsensusapp
    - djangoconsensusapp-tests

- name: Run django_consensus tests
  command: "tox -r -e {{ item }}"
  with_items: "{{ djangoconsensusapp_django_consensus_tests }}"
  args:
    chdir: "{{ djangoconsensusapp_django_consensus_basedir }}"
  when: djangoconsensusapp_django_consensus_tests_run == 1
  tags:
    - djangoconsensusapp
    - djangoconsensusapp-tests

- package:
    name: "{{item}}"
    state: latest
    # state: absent
  with_items: "{{ djangoconsensusapp_uninstall_packages }}"
  tags:
    - djangoconsensusapp
    - djangoconsensusapp-install
    - djangoconsensusapp-configuration
